var validaty = new function() {

	// private functions
	// -----------------

	this.init = function() {
		this.pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.validaty.");

		// developer or not?
		validaty.dev = false;
		try {
			validaty.dev = this.pref.getBoolPref("developer");
		} catch(e) {
		}
		traceLog("Validaty - 1.0.0");

		try {
			// listen for when the user switches tabs
			gBrowser.mTabContainer.addEventListener("select", function(e) {validaty.resetValidator(1);}, true);
		} catch(e) {
			traceLog("tab switch error");
			Components.utils.reportError(e)
		}
	},

	this.initevery = function(aEvent) {
		// see http://kb.mozillazine.org/On_page_load
		if (aEvent.originalTarget.nodeName == "#document") {
			//traceLog("every load");
			this.resetValidator(1);
		}
	},

	this.initeveryun = function(aEvent) {
		if (aEvent.originalTarget.nodeName == "#document") {
			//traceLog("every unload");
			this.resetValidator(2);
			try {
				// try to avoid leaks
				gBrowser.mTabContainer.removeEventListener("select", function(e) {validaty.resetValidator(1);}, true);
			} catch(e) {
				traceLog("tab switch unload error");
				Components.utils.reportError(e)
			}
		}
	},

	this.resetValidator = function(aState) {
		// reset the validator icon
		var but = document.getElementById("validaty-toolbar");
		if (!but) {
			traceLog("no need to update -  reset");
		} else {
			traceLog("resetting icon");
			but.removeAttribute("tooltiptext");
			if (aState) {
				if (aState == 2) {
					traceLog("disabled due to unload");
					but.setAttribute("disabled", true);
				} else {
					traceLog("set tooltip due to load");
					var bun = document.getElementById("bundle_validaty");
					but.setAttribute("tooltiptext", bun.getString("validate-ready.tooltiptext"));
					but.removeAttribute("disabled");
				}
			} else {
				traceLog("remove disabled");
				but.removeAttribute("disabled");
			}
			but.removeAttribute("type");
			but.removeAttribute("valid");
			but.removeAttribute("fail");
			but.removeAttribute("working");
		}
	},

	this.lp = function(aUrl) {
		loadPage(aUrl);
		return false;
	},

	this.validatePage = function() {
		this.resetValidator();
		var uu = getURL();
		// make sure we have a page that we can validate
		var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
		uri.spec = uu;
		var but = document.getElementById("validaty-toolbar");
		var bun = document.getElementById("bundle_validaty");
		if (uri.scheme && uri.host && uri.scheme != "about") {
			but.setAttribute("disabled", true);
			but.setAttribute("working", true);
			but.setAttribute("tooltiptext", bun.getString("validate-working.tooltiptext"));
			traceLog("about to validate: " + uu);
			var valurl;
			try {
				valurl = validaty.pref.getCharPref("validatorurl");
			} catch(e) {
				traceLog("unable to get validator url");
				Components.utils.reportError(e);
			}
			valurl += "check?output=xml&uri=" + escape(uu);
			traceLog("full validate: " + valurl);
			var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
			req.onreadystatechange = function() {
				if (req.readyState == 4) {
					but.removeAttribute("working");
					but.removeAttribute("disabled");
					var ok = false;
					if (req.status == 200) {
						var doc = req.responseXML;
						if (doc) {
							try {
								// xml needs to have uri to be valid
								var uri = doc.getElementsByTagName("uri");
								if (uri && uri.length && uri.item(0).firstChild && uri.item(0).firstChild.nodeValue) {
									var errors = doc.getElementsByTagName("errors").item(0).firstChild.nodeValue;
									traceLog("Errors: " + errors);
									if (errors > 0) {
										but.setAttribute("tooltiptext", replaceInsert(bun.getString("validate-errors.tooltiptext"), 1, errors));
										but.setAttribute("valid", false);
										but.setAttribute("type", "menu-button");
										var ele = document.createElement("menupopup");
										but = but.appendChild(ele);
										ele = document.createElement("menuitem");
										ele.setAttribute("label", replaceInsert(bun.getString("validate-report.label"), 1, errors));
										ele.setAttribute("oncommand", "validaty.lp(\"http://validator.opasia.dk/check?ss=1&uri=" + escape(uu) + "\"); event.stopPropagation();");
										but.appendChild(ele);
									} else {
										but.setAttribute("valid", true);
										but.setAttribute("tooltiptext", bun.getString("validate-errors-no.tooltiptext"));
									}
									ok = true;
								} else {
									traceLog("no uri in: " + req.responseText);
								}
							} catch(e) {
								Components.utils.reportError(e);
								traceLog("no uri in: " + req.responseText);
							}
						} else {
							traceLog("no responseXML");
						}
					} else {
						traceLog("error loading " + valurl + ". Status was " + req.status);
					}
					if (!ok) {
						but.setAttribute("tooltiptext", bun.getString("validate-no.label"));
						but.setAttribute("fail", true);
					}
				}
			}
			req.open("GET", valurl);
			req.send(null);
		} else {
			but.setAttribute("tooltiptext", bun.getString("validate-no.label"));
			but.setAttribute("fail", true);
			traceLog("unable to validate " + uu);
		}
	};

	// public functions
	// ----------------

	function getDocument() {
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var recentWindow = wm.getMostRecentWindow("navigator:browser");
		var ret = false;
		try {
			if (recentWindow) {
				ret = recentWindow.content.document;
			}
		} catch(e) {
			traceLog("unable to get document");
			Components.utils.reportError(e);
		}
		return ret;
	};

	function getURL() {
		var doc = getDocument();
		var loc = "";
		try {
			if ("location" in doc) {
				if ("href" in doc.location) {
					loc = doc.location.href;
				} else {
					traceLog("no href in doc.location");
				}
			} else {
				traceLog("no location in doc");
			}
		} catch(e) {
			traceLog("unable to get url");
			Components.utils.reportError(e)
		}
		return loc;
	};

	function replaceInsert(aTxt, aNumber, aTxtReplace) {
		var result = aTxt;
		if (result) {
			var re = new RegExp("#" + aNumber, "g");
			result = result.replace(re, aTxtReplace);
		}
		return result;
	};

	function traceLog(aText, aForce) {
		if (aForce || validaty.dev) {
			try {
				var CONSOLE_SERVICE = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
				CONSOLE_SERVICE.logStringMessage("validaty: " + aText);
			} catch(e) {
			}
		}
	};

	function loadPage(aUrl, aCurrentTab) {
		var windowService = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var currentWindow = windowService.getMostRecentWindow("navigator:browser");
		if (currentWindow) {
			try {
				if (aCurrentTab) {
					currentWindow.loadURI(aUrl);
				} else {
					currentWindow.delayedOpenTab(aUrl);
				}
			} catch(e) {
				currentWindow.loadURI(aUrl);
			}
		} else {
			window.open(aUrl);
		}
	};

}

// start it the first time we start the app
window.addEventListener("load", function(e) {validaty.init(e)}, false);
// start it every time a page has loaded and unloaded
if (document.getElementById("appcontent")) {
	document.getElementById("appcontent").addEventListener("DOMContentLoaded", function(e) {validaty.initevery(e)}, true);
	document.getElementById("appcontent").addEventListener("unload", function(e) {validaty.initeveryun(e)}, true);
}
